// Bicycle.cpp: implementation of the CBicycle class.
// bjornsta 9/98
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"
#include "Bicycle.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#include "oglview.h"

GLUquadric *glpQB;

// Variabler som bestemmer utseendet p sykkelen

//float size = 40.0f;

float cylinder_radius = 0.015f;
int cylinder_quality = 10;
float ramme_part_size[] = {0.60f, 0.24f, 0.60f, 0.63f};
float ramme_part_angle[] = {60.0f, -20.0f, -20.0f, 90.0f};
float pedal_main_angle = 10.0f;
float pedal_foot_angle = 0.0f;
float pedal_part_length[] = {0.14f, 0.15f, 0.01f};
float pedal_width = 0.09f;
float pedal_length = 0.06f;

float seat_cyl_length[] = {0.02f, 0.06f, 0.16f, 0.01f};
float seat_cyl_rad[4][2] = {{0.13f, 0.0f}, {0.13f, 0.09f}, {0.09f, 0.04f}, {0.04f, 0.0f}};
float seat_height = 0.07f;

float gaffel1_part[] = {0.10f, 0.34f};
float kjede_iRad = 0.01f;
float kjede_yRad = 0.08f;
float kjede_len = 0.40f;
float wheel_rad = 0.28f;
float wheel_width = 0.025f;
float gaffel2_angle[] = {215.0f, 8.5f};
float gaffel2_part[] = {0.46f, 0.15f, 0.05f, 0.14f};
float gaffel2_rad = 0.01f;
float gaffel3_part[] = {0.4f};
float gaffel3_angle[] = {0.0f};

float styre_part[] = {0.1f, 0.3f, 0.15f};
float styre_angle[] = {50.0f};
float styre_cyl_rad[] = {0.01f, 0.015f};
float frontwheel_rotate = 0.0f;
float eiker_rotate = 0.0f;
int antall_eiker = 7;

int list_ramme = 0;
int list_pedal = 0;
int list_seat = 0;
int list_forhjul = 0;
int list_bakhjul = 0;
int list_styre = 0;

bool ramme_changed = true;
bool pedal_changed = true;
bool seat_changed = true;
bool forhjul_changed = true;
bool bakhjul_changed = true;
bool styre_changed = true;
bool eiker_changed = true;

#define DEFAULT_MATERIAL COPPER
#define SEAT_MATERIAL BLACK_RUBBER

bool visible = true;

//

void CBicycle::drawSeat()
{
	if(seat_changed) {
		glDeleteLists(list_seat, 1);
		list_seat = glGenLists(1);
		glNewList(list_seat, GL_COMPILE);
			
		transToSeat();

		glScalef(1.0f, 1.0f, 0.4f);
		// Forutsetter at origo er p toppen av stangen setet er festet til.
		glTranslatef(-seat_cyl_length[1]/2.0f, 0.0f, seat_height/2.0f);
		glRotatef(-90.0f, 0.0f, 1.0f, 0.0f);
		
		gluCylinder(glpQB, seat_cyl_rad[0][0], seat_cyl_rad[0][1], seat_cyl_length[0], 
					cylinder_quality, cylinder_quality);
		glRotatef(180.0f, 1.0f, 0.0f, 0.0f);
		gluCylinder(glpQB, seat_cyl_rad[1][0], seat_cyl_rad[1][1], seat_cyl_length[1],
					cylinder_quality, cylinder_quality);
		glTranslatef(0.0f, 0.0f, seat_cyl_length[1]);
		gluCylinder(glpQB, seat_cyl_rad[2][0], seat_cyl_rad[2][1], seat_cyl_length[2],
					cylinder_quality, cylinder_quality);
		glTranslatef(0.0f, 0.0f, seat_cyl_length[2]);
		//gluCylinder(glpQB, seat_cyl_rad[3][0], seat_cyl_rad[3][1], seat_cyl_length[3],
		//			cylinder_quality, cylinder_quality);
		gluDisk(glpQB, 0.0f, seat_cyl_rad[3][0], cylinder_quality, cylinder_quality);
		glEndList();

		seat_changed = false;
	}
	glCallList(list_seat);
}

void CBicycle::drawPedaler()
{
	if(pedal_changed) {
		glDeleteLists(list_pedal, 1);
		list_pedal = glGenLists(1);
		glNewList(list_pedal, GL_COMPILE);
	// Forutsetter at origo er i bunnen av rammen.
		for(int i = 1; i > -2; i-=2) { // i = 1: hoeyre pedal, i = -1: venstre pedal
			glPushMatrix();
				glRotatef(i*90.0f, 1.0f, 0.0f, 0.0f);
				//glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
				drawCylinder(cylinder_radius, pedal_part_length[0] / 2);
				glTranslatef(0.0f, 0.0f, pedal_part_length[0] * 0.25);
				if(i == 1) {
					CMaterial::SetMaterial(SEAT_MATERIAL);
					gluDisk(glpQB, kjede_iRad, kjede_yRad, 20, 20);
					glPushMatrix();
						glRotatef(180.0f, 1.0f, 0.0f, 0.0f);
						gluDisk(glpQB, kjede_iRad, kjede_yRad, 20, 20);
					glPopMatrix();
					CMaterial::SetMaterial(DEFAULT_MATERIAL);

				}
				glTranslatef(0.0f, 0.0f, pedal_part_length[0] * 0.25);
				drawKule(cylinder_radius);
				glRotatef(i*(-90.0f), 1.0f, 0.0f, 0.0f);
				glRotatef(i*90.0f+(pedal_main_angle-90.0f), 0.0f, 1.0f, 0.0f);
				drawCylinder(cylinder_radius, pedal_part_length[1]);
				glTranslatef(0.0f, 0.0f, pedal_part_length[1]);
				drawKule(cylinder_radius);
				glRotatef(i*90.0f, 1.0f, 0.0f, 0.0f);
				drawCylinder(cylinder_radius, pedal_part_length[2]);
				glTranslatef(0.0f, 0.0f, pedal_part_length[2]);
				glRotatef(i*(-90.0f), 1.0f, 0.0f, 0.0f);

				glRotatef(-(i*90.0f+(pedal_main_angle-90.0f))+pedal_foot_angle, 0.0f, 1.0f, 0.0f);
				
				glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
				glRotatef((90.0f*i)-90, 0.0f, 1.0f, 0.0f);
				//glTranslatef(0.0f, 0.0f, -pedal_width/2);
				//glRotatef(90.0f, 0.0f, 0.0f, 1.0f);
				glScalef(1.0f, 0.2f, 1.0f);
				drawClosedCylinder(pedal_length/2, pedal_width);
			glPopMatrix();
		}
		glEndList();
		pedal_changed=false;
	}
	glCallList(list_pedal);
}




CBicycle::CBicycle()
{
	glpQB = gluNewQuadric();
	bx = by = bz = 0.0f;
}

CBicycle::~CBicycle()
{
	
}

void CBicycle::drawBike()
{
	if(!visible)
		return;
	glTranslatef(bx, by, bz);
	glPushMatrix();		
		CMaterial::SetMaterial(DEFAULT_MATERIAL);
		glPushMatrix();
			drawRamme();
		glPopMatrix();

		glPushMatrix();
			drawStyre();
		glPopMatrix();

		glPushMatrix(); 
			drawFrontWheel();
		glPopMatrix();
		CMaterial::SetMaterial(DEFAULT_MATERIAL);
		glPushMatrix();
			drawBackWheel();
		glPopMatrix();

		CMaterial::SetMaterial(DEFAULT_MATERIAL);
		glPushMatrix(),
			drawPedaler();
		glPopMatrix();
		CMaterial::SetMaterial(BLACK_RUBBER);
		glPushMatrix();
			drawSeat();
		glPopMatrix();	
		CMaterial::SetMaterial(DEFAULT_MATERIAL);
	glPopMatrix();
}

void CBicycle::drawRamme()
{

	if(ramme_changed) {
		glDeleteLists(list_ramme, 1);
		list_ramme = glGenLists(1);
		glNewList(list_ramme, GL_COMPILE);
		
			glPushMatrix();
				glRotatef(ramme_part_angle[0], 0.0f, 1.0f, 0.0f);
				drawCylinder(cylinder_radius, ramme_part_size[0]);
				glTranslatef(0.0f, 0.0f, ramme_part_size[0]);

				glRotatef(-ramme_part_angle[0]+ramme_part_angle[1], 0.0f, 1.0f, 0.0f);
				glTranslatef(0.0f, 0.0f, -ramme_part_size[1]*0.25f);
				drawClosedCylinder(cylinder_radius, ramme_part_size[1]);

			glPopMatrix();
			glRotatef(ramme_part_angle[2], 0.0f, 1.0f, 0.0f);
			drawCylinder(cylinder_radius, ramme_part_size[2]);

			glTranslatef(0.0f, 0.0f, ramme_part_size[2]*0.66f);
			glRotatef(-ramme_part_angle[2]+ramme_part_angle[3], 0.0f, 1.0f, 0.0f);
			drawCylinder(cylinder_radius, ramme_part_size[3]);

		glEndList();
		ramme_changed = false;
	}
	glCallList(list_ramme);

}

void CBicycle::drawCylinder(float rad, float height)
{
	gluCylinder(glpQB, rad, rad, height, cylinder_quality, cylinder_quality);
}


void CBicycle::bevegPedal(float angle, float angle2)
{
	pedal_main_angle += (float) (int) angle;
	pedal_foot_angle += angle2;
	pedal_changed = true;
}

void CBicycle::transToSeat()  // Translate til sykkelsete
{
	// Forutsetter at origo er i bunnen av rammen
	glRotatef(ramme_part_angle[2], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, ramme_part_size[2]);
	glRotatef(-ramme_part_angle[2], 0.0f, 1.0f, 0.0f);
}



void CBicycle::drawGaffel1()
{
	// Forutsetter origo p enden av stanga som gr ned til forhjulet, og z-akse
	// i samme retning som denne stanga.

	glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, -gaffel1_part[0]/2);
	drawKule(cylinder_radius);
	glPushMatrix();
		drawCylinder(cylinder_radius, gaffel1_part[0]);
		glRotatef(-90.0f, 1.0f, 0.0f, 0.0f);
		drawCylinder(cylinder_radius, gaffel1_part[1]);
	glPopMatrix();
	glTranslatef(0.0f, 0.0f, gaffel1_part[0]);
	drawKule(cylinder_radius);
	glRotatef(-90.0f, 1.0f, 0.0f, 0.0f);
	drawCylinder(cylinder_radius, gaffel1_part[1]);
	glTranslatef(0.0f, 0.0f, gaffel1_part[1]);
	drawKule(cylinder_radius);
	glRotatef(-90.0f, 1.0f, 0.0f, 0.0f);
	drawCylinder(cylinder_radius, gaffel1_part[0]);
	glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
	glTranslatef(0.0f, gaffel1_part[0], 0.0f);
	drawKule(cylinder_radius);
	glTranslatef(0.0f, -gaffel1_part[0]*0.5, 0.0f);



	// Origo i senter for hjul
}

void CBicycle::drawFrontWheel()
{	
	if(forhjul_changed) {
		glDeleteLists(list_forhjul, 1);
		list_forhjul = glGenLists(1);
		glNewList(list_forhjul, GL_COMPILE);

		transToFrontWheel();  // Origo fra bunnen av ramme, til enden av stang til
								// forhjul.
		glRotatef(frontwheel_rotate, 0.0f, 0.0f, 1.0f);
		CMaterial::SetMaterial(DEFAULT_MATERIAL);
		drawGaffel1();	

		CMaterial::SetMaterial(BLACK_RUBBER);

		glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		drawWheel(wheel_rad, wheel_width, 0.0f);

		glEndList();

		forhjul_changed = false;
	}
	glCallList(list_forhjul);
	
}	

void CBicycle::transToFrontWheel()
{
	glRotatef(ramme_part_angle[0], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, ramme_part_size[0]);
	glRotatef(-ramme_part_angle[0]+ramme_part_angle[1], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, -ramme_part_size[1]*0.25f);
	glRotatef(180.0f,0.0f, 1.0f, 0.0f);
}

void CBicycle::drawWheel(float rad, float width, float quality)
{
	glDisable(GL_CULL_FACE);
	glTranslatef(0.0f, 0.0f, width/2);
	gluDisk(glpQB, rad - width, rad, 20, 20);
	glPushMatrix();
		drawEiker(rad, antall_eiker, 0);
	glPopMatrix();
	glTranslatef(0.0f, 0.0f, -width);	
	gluDisk(glpQB, rad - width, rad, 20, 20);
	glPushMatrix();
		drawEiker(rad, antall_eiker, 6);
	glPopMatrix();
	gluCylinder(glpQB, rad, rad, width, 30,30);
	gluCylinder(glpQB, rad-width, rad-width, width, 30,30);
	//drawCylinder(rad-width, width);
	glEnable(GL_CULL_FACE);
}


void CBicycle::drawBackWheel()
{
	if(bakhjul_changed = true) {
		glDeleteLists(list_bakhjul, 1);
		list_bakhjul = glGenLists(1);
		glNewList(list_bakhjul, GL_COMPILE);

		transToBackWheel(); // Origo fra bunnen av ramme, til enden av stang til bakhjul.

		drawGaffel2();

		CMaterial::SetMaterial(BLACK_RUBBER);
		glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		glPushMatrix();
			drawWheel(wheel_rad, wheel_width, 0.0f);
		glPopMatrix();

		drawGaffel3();


		glEndList();

		bakhjul_changed = false;
	}
	glCallList(list_bakhjul);
	
}

void CBicycle::drawGaffel2()
{
	// Origo er ved begynnelse av gaffel, z peker i gaffel-retning

	glRotatef(gaffel2_angle[1], 1.0f, 0.0f, 0.0f);
	drawCylinder(gaffel2_rad, gaffel2_part[0]);
	glRotatef(-2*gaffel2_angle[1], 1.0f, 0.0f, 0.0f);
	drawCylinder(gaffel2_rad, gaffel2_part[0]);
	glPushMatrix();
		glTranslatef(0.0f, 0.0f, gaffel2_part[1]);
		glRotatef(gaffel2_angle[1]+90.0f, 1.0f, 0.0f, 0.0f);
		drawCylinder(gaffel2_rad, gaffel2_part[2]);
	glPopMatrix();
	glTranslatef(0.0f, 0.0f, gaffel2_part[0]);
	drawKule(gaffel2_rad);
	glPushMatrix();
		glRotatef(gaffel2_angle[1]+90.0f, 1.0f, 0.0f, 0.0f);
		drawCylinder(gaffel2_rad, gaffel2_part[3]);
		glTranslatef(0.0f, 0.0f, gaffel2_part[3]);
		drawKule(gaffel2_rad);
	glPopMatrix();
	glRotatef(gaffel2_angle[1], 1.0f, 0.0f, 0.0f);

	glTranslatef(0.0f, -gaffel2_part[3]*0.75, 0.0f);
	glPushMatrix();
		glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		CMaterial::SetMaterial(SEAT_MATERIAL);
		gluDisk(glpQB, kjede_iRad, kjede_yRad, 20, 20);
		glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
		gluDisk(glpQB, kjede_iRad, kjede_yRad, 20, 20);
		glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
		
		glRotatef(90.0f, 0.0f, 1.0f, 0.0f);
		glRotatef(-gaffel2_angle[0]-90.0f, 1.0f, 0.0f, 0.0f);
		glTranslatef(0.0f, 0.0f, kjede_yRad);
		glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		glBegin(GL_LINES);
			glVertex3f(0.0f, 0.0f, kjede_len);
			glVertex3f(0.0f, 0.0f, 0.0f);
		glEnd();
		glTranslatef(0.0f, -2*kjede_yRad, 0.0f);
		glBegin(GL_LINES);
			glVertex3f(0.0f, 0.0f, kjede_len);
			glVertex3f(0.0f, 0.0f, 0.0f);
		glEnd();

		CMaterial::SetMaterial(DEFAULT_MATERIAL);
	glPopMatrix();
	glTranslatef(0.0f, gaffel2_part[3]*0.25, 0.0f);
	

	// Origo er i senter av hjulet
}

void CBicycle::transToBackWheel()
{

	glRotatef(ramme_part_angle[2], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, ramme_part_size[2]*0.66f);
	glRotatef(-ramme_part_angle[2]+gaffel2_angle[0], 0.0f, 1.0f, 0.0f);
	
}

void CBicycle::drawStyre()
{
	if(styre_changed) {
		glDeleteLists(list_styre, 1);
		list_styre = glGenLists(1);
		glNewList(list_styre, GL_COMPILE);

		// Origo i bunnen av rammen.
		transToStyre();
		// Origo der styret mter rammen, z peker oppover
		glRotatef(-frontwheel_rotate, 0.0f, 0.0f, 1.0f);
		
		glRotatef(styre_angle[0], 0.0f, 1.0f, 0.0f);
		drawCylinder(styre_cyl_rad[0], styre_part[0]);
		glTranslatef(0.0f, 0.0f, styre_part[0]);
		
		glRotatef(90.0f, 1.0f, 0.0f, 0.0f);

		glTranslatef(0.0f, 0.0f, -styre_part[1]/2 - styre_part[2]);
		CMaterial::SetMaterial(BLACK_RUBBER);
		drawClosedCylinder(styre_cyl_rad[1], styre_part[2]);
		glTranslatef(0.0f, 0.0f, styre_part[2]);
		CMaterial::SetMaterial(DEFAULT_MATERIAL);
		drawCylinder(styre_cyl_rad[0], styre_part[1]);
		glTranslatef(0.0f, 0.0f, styre_part[1]);
		CMaterial::SetMaterial(BLACK_RUBBER);
		drawClosedCylinder(styre_cyl_rad[1], styre_part[2]);

		glEndList();

		styre_changed = false;
	}
	glCallList(list_styre);
}

void CBicycle::transToStyre()
{
	glRotatef(ramme_part_angle[0], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, ramme_part_size[0]);

	glRotatef(-ramme_part_angle[0]+ramme_part_angle[1], 0.0f, 1.0f, 0.0f);
	glTranslatef(0.0f, 0.0f, ramme_part_size[1]*0.75f);
}

void CBicycle::turnBike(float rot)
{
	frontwheel_rotate += rot;
	styre_changed = true;
	forhjul_changed = true;
}

float CBicycle::getDirection()
{	
	return frontwheel_rotate;
}

void CBicycle::drawGaffel3()
{
	CMaterial::SetMaterial(DEFAULT_MATERIAL);

	glTranslatef(0.0f, 0.0f, gaffel2_part[3]/2);
	glRotatef(90.0f, 0.0f, 1.0f, 0.0f);
	glRotatef(gaffel3_angle[0]-gaffel2_angle[0], 1.0f, 0.0f, 0.0f);

	drawCylinder(cylinder_radius, gaffel3_part[0]);

	glTranslatef(gaffel2_part[3], 0.0f, 0.0f);

	drawCylinder(cylinder_radius, gaffel3_part[0]);

}

void CBicycle::drawEiker(float rad, int n, float start)
{
	glRotatef(start-eiker_rotate, 0.0f, 0.0f, 1.0f);
	float a = (360.0f/n);
	int i;
	for(i = 0; i < n; i ++) {
		glBegin(GL_LINES);
			glVertex3f(0.0f, rad, 0.0f);
			glVertex3f(0.0f, 0.0f, 0.0f);
		glEnd();
		glRotatef(a, 0.0f, 0.0f, 1.0f);
	}
}

void CBicycle::rotateWheel(float r)
{
	eiker_rotate+=r;
	if(eiker_rotate > 360.0f)
		eiker_rotate -= 360.0f;
	forhjul_changed = true;
	bakhjul_changed = true;
}

void CBicycle::drawClosedCylinder(float r, float h)
{
	drawCylinder(r, h);
	glPushMatrix();
		glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
		gluDisk(glpQB, 0.0f, r, cylinder_quality, cylinder_quality);
		glRotatef(180.0f, 0.0f, 1.0f, 0.0f);
		glTranslatef(0.0f, 0.0f, h);
		gluDisk(glpQB, 0.0f, r, cylinder_quality, cylinder_quality);
	glPopMatrix();
}

void CBicycle::drawKule(float rad)
{
	gluSphere(glpQB, rad, cylinder_quality, cylinder_quality);
}


// Translate to where robot meets seat.

void CBicycle::transToSeatRobot()
{
	transToSeat();
	glTranslatef(0.0f, 0.0f, seat_height);
	glTranslatef(seat_cyl_length[1], 0.0f, 0.0f);
}

float CBicycle::seatToLPedalX() {
	return calcPedalX(pedal_main_angle);
}

float CBicycle::seatToLPedalY() {	
	return calcPedalY(pedal_main_angle);	
}

float CBicycle::seatToRPedalX()
{
	return calcPedalX(pedal_main_angle-180.0f);
}

float CBicycle::seatToRPedalY()
{
	return calcPedalY(pedal_main_angle-180.0f);
}

float CBicycle::calcPedalX(float angle)
{
	float PI = 3.14159;
	return 0 + seat_cyl_length[1] + sin(PI*ramme_part_angle[2]/180.0f)*ramme_part_size[2]
		+ sin(PI*angle/180.0f)*pedal_part_length[1]
		+ pedal_width;
}

float CBicycle::calcPedalY(float angle)
{
	float PI = 3.14159;
	return 0 - seat_height - cos(PI*ramme_part_angle[2]/180.0f)*ramme_part_size[2]
		- cos(PI*angle/180.0f)*pedal_part_length[1] + 0.02;

}

int CBicycle::getPedalAngle()
{
	return (int) pedal_main_angle;
}

float CBicycle::calcLStyreX(float retning)
{
	return 0.0f;
}

float CBicycle::calcLStyreY(float retning)
{
	return 0.0f;
}

void CBicycle::transToGround()
{
	glTranslatef(0.0f, 0.0f, -wheel_rad-wheel_width);
}

void CBicycle::setVisible(bool vis)
{
	visible = vis;
}
