// Scenery.cpp: implementation of the CScenery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Std.h"
#include "Scenery.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

float road_len = 200.0f, road_width = 6.0f;
float stripe_len = 3.0f, stripe_width = 0.15f, stripe_pause = 2.0f;
float grass_width = 50.0f;
float sky_height = 100.0f;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CScenery::CScenery()
{

}

CScenery::~CScenery()
{

}

void CScenery::drawScenery()
{
	glTranslatef(0.0f, road_width/4, 0.0f);

	glPushMatrix();
		drawRoad();
	glPopMatrix();
	glPushMatrix();
		drawHouse();
	glPopMatrix();
	glPushMatrix();
		drawGrass();
	glPopMatrix();
	//glPushMatrix();
	//	drawSky();
	//glPopMatrix();
	
}

void CScenery::drawRoad()
{
	float strip_color[9] = 
		{1.0f, 1.0f, 0.0f,
		1.0f, 1.0f, 0.0f,
		1.0f, 1.0f, 0.0f};
	CMaterial::SetMaterial(ASFALT);
	glBegin(GL_QUADS);
		glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(road_len/2, -road_width/2, 0.0f);
		glVertex3f(road_len/2, road_width/2, 0.0f);
		glVertex3f(-road_len/2, road_width/2, 0.0f);
		glVertex3f(-road_len/2, -road_width/2, 0.0f);
	glEnd();
	//CMaterial::SetMaterial(YELLOW_RUBBER);
	CMaterial::setNewMaterial(strip_color);
	glBegin(GL_QUADS);
		glNormal3f(0.0f, 0.0f, 1.0f);
		for(int x = -road_len/2; x < road_len/2; x+= stripe_pause+stripe_len) {
			glVertex3f(x+stripe_len, -stripe_width/2, 0.01f);
			glVertex3f(x+stripe_len, stripe_width/2, 0.01f);
			glVertex3f(x, stripe_width/2, 0.01f);
			glVertex3f(x, -stripe_width/2, 0.01f);
		}
	glEnd();
}

void CScenery::drawHouse()
{

}

void CScenery::drawGrass()
{
	float grass_color[9] = 
	{0.0f, 0.5f, 0.0f,
	0.0f, 0.5f, 0.0f,
	0.0f, 0.1f, 0.0f};
	CMaterial::setNewMaterial(grass_color);
	glBegin(GL_QUADS);
		glNormal3f(0.0f, 0.0f, 1.0f);
		glVertex3f(-road_len/2, -road_width/2, 0.0f);
		glVertex3f(-road_len/2, -road_width/2 - grass_width, 0.0f);
		glVertex3f(road_len/2, -road_width/2 - grass_width, 0.0f);
		glVertex3f(road_len/2, -road_width/2, 0.0f);

		glVertex3f(road_len/2, road_width/2, 0.0f);
		glVertex3f(road_len/2, road_width/2 + grass_width, 0.0f);
		glVertex3f(-road_len/2, road_width/2 + grass_width, 0.0f);
		glVertex3f(-road_len/2, road_width/2, 0.0f);
	glEnd();
}

void CScenery::drawSky()
{
	float sky_color[9] = 
	{0.3f, 0.3f, 1.0f,
	0.3f, 0.3f, 1.0f,
	0.3f, 0.3f, 1.0f};

	CMaterial::setNewMaterial(sky_color);
	glBegin(GL_QUADS);
		glNormal3f(0.0f, 1.0f, 0.0f);
		glVertex3f(-road_len/2, -road_width/2 - grass_width, 0.0f);
		glVertex3f(-road_len/2, -road_width/2 - grass_width, sky_height);
		glVertex3f(road_len/2, -road_width/2 - grass_width, sky_height);
		glVertex3f(road_len/2, -road_width/2 - grass_width, 0.0f);
	glEnd();
}
